/* ujas Fleur 2: 
Steine entfernen wie Fleur, (ohne Schwerkraftmodus), zustzlich Blockade, Joker, Vierfarbsteine - Bombas und Dreher
Levelcode: 0:frei fuer Stein, 1:Blockstein, 2 normaler Stein, paarig, 3:Joker, paarig, 4,5,6: Vierfarbstein, je paarig
V.0.90: 20.05.2005: erste Veroeffentlichung mit 12 Levels (beta 1)
V.0.95: 21.05.2005: (beta 2) 
                    Bug bei 2 gleichen Sondersteinen behoben, 
                    Level Burg entschaerft
                    Wechsler eingebaut (Codes 9,a,b,c)
V.0.96: 22.05.2005: bugfix bei Dreher und Pfadsuche Zweieck, gain auf Bomba und Dreher ausgeweitet, Levels entschaerft

V.1.0:  23.05.2005: Leveleditor
V.1.1:  24.05.2005: NAS-Sound
V.1.2:  26.06.2005: anderer Hintergrund, Steinanimation beim Verschwinden
V.1.3:  28.05.2005: bugfix Jokerhandling
V.1.4:  29.05.2005: 2 Lautstaerken
V.1.5:  03.06.2005: eigenes aRts-Interface fuer Soundfiles
*/

#include <math.h>
#include "game.h"
#include <qsound.h>
#include "stdio.h"

// Listenroutinen-Auszug: (c)uja 1989
int  in_liste(int e,int* l)       { int i,k=-1; if (l[0]>0) for (i=1; i<=l[0]; i++) if (e==l[i]) k=i; return k; }
void add_liste(int e,int* l)      { if (in_liste(e,l)<1) { l[0]++; l[l[0]]=e; } }
void merge_liste(int* l1,int* l)  { if (l1[0]>0) for (int i=1; i<=l1[0]; i++) add_liste(l1[i],l); }

// ============================================================================================================================
chip::chip(int nr) { id=nr; phase=-1; timrec_c=new QTimer(); } // Deckel um Sprite verschwinden zu lassen

void chip::wipeout()
{ phase++;
  if (phase<8) { p_sprite->setFrame(phase); p_sprite->show(); timrec_c->singleShot(25,this,SLOT(wipeout())); }
  else { phase=-1; p_sprite->hide(); }
}

void chip::explo()
{ phase++;
  if (phase<8) { p_sprite->setFrame(phase+8); p_sprite->show(); timrec_c->singleShot(25,this,SLOT(explo())); }
  else { phase=-1; p_sprite->hide(); }
}


// =============================================================================================================================

game::game(QWidget* parent)
{ int i;
  oberer=parent;
  tic1=50; tic2=200; c_satz=0;
  aktiv=false; over=false; pausiert=false; soundon=0;
  my_levelliste=new level(QString("levels.csv"));
  levelid=0; aktlevel=0; punkte=0; punkte0=0; zeit0=300; zeit=zeit0; nfarben=12;
  for (i=0; i<SMAX; i++) { f[i]=-1; block[i]=new chip(i); }
  // Sekundenticker und Ani-Ticker:  
  timrec1=new QTimer(); connect(timrec1,SIGNAL(timeout()),this,SLOT(countdown()));  timrec1->start(1000);
  timrec2=new QTimer();
// printf("Aufbau feddich!\n");

}

// Zugauswertung: -------------------------------------------------------------------------------------------------------------
// lineare Verbindung, entweder waagerecht oder senkrecht - nur Check nach Hindernissen - fuellt bei Erfolg Pfadliste l
bool game::is_linie(int n1,int n2,int l[]) 
{ int i,k,x1,x2,y1,y2;
  if (n1>n2) { k=n1; n1=n2; n2=k; }
  x1=n1%XMAX,x2=n2%XMAX,y1=(n1-x1)/XMAX,y2=(n2-x2)/XMAX; // Koordinaten
  bool ok=false,waagerecht=(y1==y2),senkrecht=(x1==x2);
  l[0]=0;
  if (senkrecht)
  { ok=true;
    for (i=y1+1; i<y2; i++) if ((f[i*XMAX+x1]+1)!=0) ok=false;   // Check Hindernisse
    if (ok) for (i=y1; i<=y2; i++) add_liste(i*XMAX+x1,l);    // Pfad
  }
  else if (waagerecht)
  { ok=true;
    for (i=n1+1; i<n2; i++) if ((f[i]+1)!=0) ok=false;   // Check Hindernisse
    if (ok) for (i=n1; i<=n2; i++) add_liste(i,l); // Pfad
  }
  return ok;
}

// eine Ecke: einer der Eckpunkte ist zwangslufigerweise x1/y2 oder x2/y1 - dieser muss frei sein
// zu testen sind die Linien x1/y1 - x1/y2 mit x1/y2 - x2/y2, alternativ x1/y1 - x2/y1 mit x2/y1 - x2/y2 
// fuellt bei Erfolg Pfadliste l
bool game::is_eineck(int n1,int n2,int l[]) 
{ int x1=n1%XMAX,x2=n2%XMAX,y1=(n1-x1)/XMAX,y2=(n2-x2)/XMAX,n3=y2*XMAX+x1,n4=y1*XMAX+x2; // Koordinaten und Ecken
  l[0]=0;
  int l1[XMAX+1],l2[XMAX+1];
  bool ok=false,obenrum=((f[n3]+1)==0),untenrum=((f[n4]+1)==0);
  if (obenrum)
  { ok=is_linie(n1,n3,l1);
    if (ok) ok=is_linie(n3,n2,l2);
    if (ok) { merge_liste(l1,l); merge_liste(l2,l); }
  }
  if (!ok) if (untenrum)
  { ok=is_linie(n1,n4,l1);
    if (ok) ok=is_linie(n4,n2,l2);
    if (ok) { merge_liste(l1,l); merge_liste(l2,l); }
  }
  return ok;
}

// Zweieck setzt sich zusammen aus 1 Linie und 1 Ecke 
// es wird auf einer waagerechten und einer senkrechten Linie nach der passenden Einecks gesucht
// Die Linien erstrecken sich von dem letzten freien Feld oberhalb/links des Startsteines bis zum letzten freien unterhalb/rechts
bool game::is_zweieck(int n1,int n2,int* l) 
{ int na,x1,x2,y1,y2,stuetz=-1;
  int l2[2*XMAX+2];
  bool ok,weiter;
  x1=n1%XMAX; y1=(n1-x1)/XMAX; x2=n2%XMAX; y2=(n2-x2)/XMAX; 
  l[0]=0;
  // Suche nach Norden, Sueden, Osten, Westen:
  na=n1;
  weiter=true;
  while (weiter)
  { na=na-XMAX;
    ok=(na>=0);
    if (ok) ok=(f[na]==-1);
    if (ok) ok=is_eineck(na,n2,l2); else weiter=false;
    if (ok) { stuetz=na; weiter=false; }
  }
  if (!ok)
  { na=n1; 
    weiter=true;
    while (weiter)
    { na=na+XMAX;
      ok=(na<SMAX);
      if (ok) ok=(f[na]==-1);
      if (ok) ok=is_eineck(na,n2,l2); else weiter=false;
      if (ok) { stuetz=na; weiter=false; }
    }
  }
  if (!ok)
  { na=n1; 
    weiter=true;
    while (weiter)
    { na++;
      x1++;
      ok=(x1<XMAX);
      if (ok) ok=(f[na]==-1);
      if (ok) ok=is_eineck(na,n2,l2); else weiter=false;
      if (ok) { stuetz=na; weiter=false; }
    }
  }
  if (!ok)
  { na=n1; 
    x1=n1%XMAX;
    weiter=true;
    while (weiter)
    { na--;
      x1--;
      ok=(x1>=0);
      if (ok) ok=(f[na]==-1);
      if (ok) ok=is_eineck(na,n2,l2); else weiter=false;
      if (ok) { stuetz=na; weiter=false; }
    }
  }
  // Liste fuellen:
  if (stuetz>=0) { is_linie(n1,stuetz,l); is_eineck(stuetz,n2,l2); merge_liste(l2,l); }
  return (stuetz>=0);
}

bool game::zugcheck(int n1,int n2)
{ bool ok=(n1!=n2);
  if (ok)
  { if (n1>n2) { int k=n1; n1=n2; n2=k; } // Koordinaten sortieren: links nach rechts, oben nach unten
    p[0]=1; p[1]=n1;
    ok=is_linie(n1,n2,p); 
    if (!ok) ok=is_eineck(n1,n2,p);
    if (!ok) ok=is_zweieck(n1,n2,p);
    if (!ok) p[0]=0;
  }
  if (ok) { add_liste(n1,p); add_liste(n2,p); }
  return ok;
}

// --- Ende Zugauswertung -------------------------------------------------------------------------------------------

void game::levelup() 
{ if (timrec2->isActive()) timrec2->stop();
  aktiv=false;
  QString temp;
  aktlevel++; 
  punkte=punkte+10*zeit;
  emit punkte_changed(punkte);
  emit messi("Bonus: "+temp.setNum(10*zeit));
  punkte0=punkte; 
  if (aktlevel<my_levelliste->anz_levels) timrec2->singleShot(1500,this,SLOT(levelstart())); 
  else { emit messi(_KEINELEVELS); timrec2->singleShot(500,this,SLOT(game_over())); }
}

// ------------------------------------------------------------------------------------------------------------------
// private slots:
void game::countdown() 
{ if (aktiv) 
  { emit zeit_changed(zeit); 
    zeit--; 
    if (zeit<0) game_over(); else // Wechsler
    { int i,k;
      if (w0_liste[0]>0) for (i=1; i<=w0_liste[0]; i++) 
      { k=w0_liste[i]; 
        if (f[k]>=0) { f[k]=(f[k]+1)%12; p_chip[k]->setFrame(f[k]); }
      }
      if (w4_liste[0]>0) for (i=1; i<=w4_liste[0]; i++) 
      { k=w4_liste[i]; 
        if (f[k]>7) f[k]=(f[k]+1)%4+8; else if (f[k]>3) f[k]=(f[k]+1)%4+4; else if (f[k]>=0) f[k]=(f[k]+1)%4; 
        p_chip[k]->setFrame(f[k]);
      }
    }
  }
}

void game::zug_beenden() // Leafnode in Animationskette 1200
{ int i,k; 
  if (p[0]>0) for (i=1; i<=p[0]; i++) { k=p[i]; f[k]=-1; p_chip[k]->hide(); p_bgr[k]->setFrame(0); }
  numchips=0; for (i=0; i<SMAX; i++) if (f[i]>=0) numchips++;
  emit rest_changed(numchips);
  if (numchips<1) levelup();
  aktiv=true;
}


// ------------------------------------------------------------------------------------------------------------------
//  public slots:
void game::neu() { aktlevel=0; punkte0=0; levelstart(); }

void game::levelstart()
{ aktiv=false; pausiert=true;
  over=false;
  if (aktlevel>=my_levelliste->anz_levels) aktlevel=my_levelliste->anz_levels-1;
// decodieren:
  int i,j,k;
  int chips[SMAX];
  QString fcode="0123456789abcdef";
  QString qf=my_levelliste->my_level[aktlevel]->levelcode;
  numchips=0;
  for (i=0; i<NUMCHIPS; i++) hfarben[i]=0;
  w0_liste[0]=0; w4_liste[0]=0;
  for (i=0; i<SMAX; i++) 
  { k=fcode.find(qf.at(i));
    switch(k)
    { case 0: f[i]=-1; p_bgr[i]->setFrame(0); break; // leeres Feld
      case 1: f[i]=-2; p_bgr[i]->setFrame(1); break; // Blockade
      case 2: f[i]=0;  p_bgr[i]->setFrame(0); numchips++; break;        // Random-Stein 0-11
      case 3: f[i]=12; p_bgr[i]->setFrame(0); break;        // Joker 
      case 4: f[i]=13; p_bgr[i]->setFrame(0); break;        // Vierer Basis 0
      case 5: f[i]=14; p_bgr[i]->setFrame(0); break;        // Vierer Basis 4
      case 6: f[i]=15; p_bgr[i]->setFrame(0); break;        // Vierer Basis 8
      case 7: f[i]=16; p_bgr[i]->setFrame(0); break;        // Bomba
      case 8: f[i]=17; p_bgr[i]->setFrame(0); break;        // Dreher
      case 9: f[i]=11; p_bgr[i]->setFrame(0); add_liste(i,w0_liste); break; // gr. Wechsler 0-12
      case 10: f[i]=3; p_bgr[i]->setFrame(0); add_liste(i,w4_liste); break;  // kl. Wechsler 0- 3
      case 11: f[i]=7; p_bgr[i]->setFrame(0); add_liste(i,w4_liste); break;  // kl. Wechsler 4- 7
      case 12: f[i]=11; p_bgr[i]->setFrame(0); add_liste(i,w4_liste); break; // kl. Wechsler 8-11
    }
    if (f[i]>=0) { p_chip[i]->setFrame(f[i]); p_chip[i]->show(); } else p_chip[i]->hide();
  }
  emit level_changed(my_levelliste->my_level[aktlevel]->titel);
  srand(time(NULL));
  k=0; for (i=0; i<SMAX/4; i++) for (j=0; j<4; j++) { chips[k]=i%NUMCHIPS; k++; } // in frage kommenden Chips sortieren, so dass 4er-Gruppen
  for (int ii=0; ii<numchips; ii++) for(i=0; i<numchips; i++) { k=rand()%numchips; j=chips[i]; chips[i]=chips[k]; chips[k]=j; } // mischen
  numchips=0;
  k=0; 
  for (i=0; i<SMAX; i++) 
  { if (f[i]==0) { f[i]=chips[k]; k++; }
    if (f[i]>=0) { numchips++; p_chip[i]->setFrame(f[i]); }
  }
  p_gover->hide();
  gewaehlt=-1;
  punkte=punkte0;
  zeit=my_levelliste->my_level[aktlevel]->maxtime;
  toggle_pause();
  emit punkte_changed(punkte);
  emit rest_changed(numchips);
  emit zeit_changed(zeit);
  emit play_lala(soundon,0);

// printf("Levelstart\n");

}

// ==================================================

void game::geklickt(int x,int y) 
{ int i,k,ix=(x-OFX)/DX,iy=(y-OFY)/DY,nr=ix+XMAX*iy;
  if (pausiert) toggle_pause(); else if (aktiv) if (f[nr]>=0)
  { emit play_lala(soundon,1);
    if (gewaehlt<0) { gewaehlt=nr; p_bgr[nr]->setFrame(2); }
    else
    { bool ok=false;
      int drehen=-1;
      int sprengen=-1;
      int gain=0;
      switch (f[gewaehlt])
      { case 12: ok=(f[nr]>=0);                 gain=500; break;   // Joker
        case 13: ok=((f[nr]>=0) && (f[nr]<4));  gain=100; break;   // Vierer 1
        case 14: ok=((f[nr]>=4) && (f[nr]<8));  gain=100; break;   // Vierer 2
        case 15: ok=((f[nr]>=8) && (f[nr]<12)); gain=100; break;   // Vierer 3
        case 16: ok=(f[nr]>=0); sprengen=f[nr];  gain=50;  break;   // Bomba
        case 17: ok=(f[nr]>=0); drehen=f[nr];    gain=200; break;   // Dreher
      }
      switch (f[nr])
      { case 12: if (!ok) ok=(f[gewaehlt]>=0);                 gain=500; break;   // Joker
        case 13: if (!ok) ok=((f[gewaehlt]>=0) && (f[gewaehlt]<4));  gain=100; break;   // Vierer 1
        case 14: if (!ok) ok=((f[gewaehlt]>=4) && (f[gewaehlt]<8));  gain=100; break;   // Vierer 2
        case 15: if (!ok) ok=((f[gewaehlt]>=8) && (f[gewaehlt]<12)); gain=100; break;   // Vierer 3
        case 16: if (!ok) ok=(f[gewaehlt]>=0); sprengen=f[gewaehlt];  gain=50;  break;   // Bomba
        case 17: if (!ok) ok=(f[gewaehlt]>=0); drehen=f[gewaehlt];    gain=200; break;   // Dreher
      }
//      printf("Steine: %i, %i\n",f[gewaehlt],f[nr]);
      if ((sprengen>=0) && (drehen>=0)) drehen=-1;
      if (!ok) ok=(f[gewaehlt]==f[nr]);
      if (ok) ok=zugcheck(nr,gewaehlt); // speichert Pfad in Feld p
      if (ok) 
      { aktiv=false; 
        for (i=1; i<=p[0]; i++) p_bgr[p[i]]->setFrame(2); // Pfad anzeigen
        QString raus; raus.setNum(gain);
        if (gain==0) emit messi(""); else emit messi("Extra: "+raus);
        punkte=punkte+10+gain; // Punktegewinn
        // Verschwindibus-Effekte:
        block[nr]->wipeout(); block[gewaehlt]->wipeout();
        if (gain==500)  emit play_lala(soundon,4);
        else if (gain==100)  emit play_lala(soundon,4);
        k=f[nr];
        if (sprengen>=0) 
        { for (i=0; i<SMAX; i++) if (f[i]==sprengen) { add_liste(i,p); if ((i!=nr) || (i!=gewaehlt)) block[i]->explo(); }
           emit play_lala(soundon,5);
        } 
        if (drehen>=0) 
        { for (i=0; i<SMAX; i++) if (f[i]==drehen) { f[i]=(f[i]+1)%12; p_chip[i]->setFrame(f[i]); }
          emit play_lala(soundon,6);
        }
        emit punkte_changed(punkte);
        emit play_lala(soundon,2);
        timrec2->singleShot(200,this,SLOT(zug_beenden()));
      }
      else { p_bgr[gewaehlt]->setFrame(0);  p_bgr[nr]->setFrame(0); emit play_lala(soundon,3); }
      gewaehlt=-1;
    }
  }
}

void game::hover(int x,int y) { p_cursor->move(x-p_cursor->width()/2,y-p_cursor->height()/2); } // ma kucken
void game::pause()        { if (aktiv) { aktiv=false; pausiert=true;  p_pause->show(); emit messi(_PAUSED); } }
void game::weiter()       { aktiv=true; pausiert=false; p_pause->hide(); emit messi(""); }
void game::toggle_pause() { emit is_pause(pausiert); if (pausiert) weiter(); else pause(); }


void game::game_over()
{ if (!over)
  { over=true;
    if (timrec2->isActive()) timrec2->stop();
    aktiv=false; 
    p_gover->show(); 
    emit play_lala(soundon,7);
    emit punkte_changed(punkte);
    emit gameover(punkte);
  }
} 


// lala:
// -----------------------------------------------------------------------------------------------------------------------------
void game::set_sound(int nr) 
{ soundon=0; // if (QSound::isAvailable())
 soundon=nr; }


// Levelkram:
// -----------------------------------------------------------------------------------------------------------------------------

void game::load_game(int nr) // Format: levelfile (erstmal nur 0),aktuelles Level, Punkte vom letzen geschafften level
{  int bufsize=254,i,k=nr+1; // Ueberschrift!
   aktiv=false;
   // speicher.ini komplett einlesen:
   QString buff,buff1,bname[MAXSPEICHER];
   QFile fh("./speicher.ini");
   if (fh.open(IO_ReadOnly))
   { fh.readLine(buff,bufsize);
     for (i=0; i<MAXSPEICHER; i++) { bname[i]=buff.section(';',i,i); }
     for (i=1; i<=k; i++) { fh.readLine(buff,bufsize); }
     buff1=buff.section(';',0,0); levelid=buff1.toInt();
     buff1=buff.section(';',1,1); aktlevel=buff1.toInt();  
     buff1=buff.section(';',2,2); punkte=buff1.toInt();
     fh.close();
   }
   QString raus;
   raus=_GAMELOADED+bname[nr];
   emit messi(raus);
   punkte0=punkte;
   levelstart();
}

void game::save_game(int nr) 
{ int bufsize=254,i,j,k=nr+1,nrecs=MAXSPEICHER;
  if (j<0) j=0;
  QString buff[nrecs+1];
  QString bu0="",bu1="",bu2="";
  QString bname[MAXSPEICHER];
  QFile fh("./speicher.ini"); 
  if (fh.open(IO_ReadOnly)) 
  { fh.readLine(buff[0],bufsize);
    for (i=0; i<MAXSPEICHER; i++) { bname[i]=buff[0].section(';',i,i); }
    for (i=1; i<=nrecs; i++) fh.readLine(buff[i],bufsize); fh.close(); }  
    buff[k]=bu0.setNum(levelid)+';'+bu1.setNum((aktlevel))+';'+bu2.setNum(punkte0)+';';
    buff[k]=buff[k]+"\n";
    if (fh.open(IO_WriteOnly)) { for (i=0; i<=nrecs; i++) { fh.writeBlock(buff[i],buff[i].length()); } 
    fh.close();
  }
  QString raus;
  raus=_GAMESAVED+bname[nr];
  emit messi(raus);
}

void game::set_chipsatz(int nr)
{ if (nr==1) { bgrarray=bgrarray2; chiparray=chiparray2; exploarray=exploarray2; }
  else { bgrarray=bgrarray1; chiparray=chiparray1; exploarray=exploarray1; }
  c_satz=nr;
  for (int i=0; i<SMAX; i++) 
  { p_bgr[i]->setSequence(bgrarray);
    p_chip[i]->setSequence(chiparray);
    block[i]->p_sprite->setSequence(exploarray);
  }
}

void game::save_settings()
{ QString zeile,feld1,feld2;;
  QFile fh("gameparm.ini"); 
  zeile=zeile.setNum(soundon); zeile=zeile+';';
  zeile=zeile+feld1.setNum(c_satz)+"\n";
  if (fh.open(IO_WriteOnly)) { fh.writeBlock(zeile,zeile.length()); fh.close(); }
  emit messi(_SETTINGSSAVED);
}

// =============================================================================================================================
