// Pusher by uja  game modul
// ----------------------------------

#ifndef GAME_H
#define GAME_H

#include <qfile.h>
#include <qcanvas.h>
#include <qtimer.h>
#include <qsound.h>

#include "config.h"
#include "lang.h"
#include "levels.h"

// ==================================================================================================================

class game;

class chip:public QWidget
{ 
  Q_OBJECT
  friend class game;

  private:
  int id,phase;
  QTimer* timrec_c;

  public:
  chip(int);
  QCanvasSprite* p_sprite;

  private slots:
  void wipeout();
  void explo();

} ;


// ============================================================================================================
class game:public QWidget
{
  Q_OBJECT

  private:
  bool aktiv,over,pausiert;
  int  levelid,soundon,c_satz,aktlevel,punkte,punkte0,zeit,zeit0,numchips,gewaehlt,nfarben;
  int  f[SMAX],p[SMAX+1],hfarben[NUMCHIPS],w0_liste[SMAX+1],w4_liste[SMAX+1];  // Feldparameter
  int  tic1,tic2;

  QWidget* oberer;
  QTimer*  timrec1;
  QTimer*  timrec2;
  level*   my_levelliste;

  void levelup();
  bool is_linie(int,int,int[]);
  bool is_eineck(int,int,int[]);
  bool is_zweieck(int,int,int[]);
  bool zugcheck(int,int);


  public:
  game(QWidget* parent);

  QCanvasPixmapArray* goverarray;
  QCanvasPixmapArray* pausearray;
  QCanvasPixmapArray* cursorarray;

  QCanvasPixmapArray* bgrarray;
  QCanvasPixmapArray* chiparray;
  QCanvasPixmapArray* exploarray;

  QCanvasPixmapArray* bgrarray1;
  QCanvasPixmapArray* chiparray1;
  QCanvasPixmapArray* exploarray1;

  QCanvasPixmapArray* bgrarray2;
  QCanvasPixmapArray* chiparray2;
  QCanvasPixmapArray* exploarray2;

  QCanvasSprite* p_gover;  
  QCanvasSprite* p_pause;
  QCanvasSprite* p_cursor;

  QCanvasSprite* p_bgr[SMAX];        // statische Sprites:  Feldelemente
  QCanvasSprite* p_chip[SMAX];       // statische Sprites, Hindernisse

  chip* block[SMAX];                 // Ani bei Entfernen der Chips


  public slots:
  void neu();
  void levelstart();
  void pause();
  void weiter();
  void game_over();
  void set_sound(int);
  void geklickt(int,int);
  void hover(int,int);
  void toggle_pause();
  void load_game(int);
  void save_game(int);
  void set_chipsatz(int);
  void save_settings();

  private slots:
  void countdown();
  void zug_beenden();

  signals:
  void gameover(int);
  void play_lala(int,int);
  void messi(QString);
  void punkte_changed(int);
  void zeit_changed(int);
  void rest_changed(int);
  void level_changed(QString);
  void is_pause(bool);
  void sound_setting0(bool);
  void sound_setting1(bool);
  void sound_setting2(bool);

} ;

#endif
