#!/bin/sh
##########################################################
# Installer ujagames_qt: fleur2 english aRts-Soundserver #
##########################################################

# Bibliotheken finden: 
########################
KDEPFAD=""
KDEPFAD="$(kde-config --prefix)"

KDELIBS="$(find $KDEPFAD|grep libartsc.so$)"
KDELIBS="$(echo $KDELIBS|sed 's/libartsc.so//')"

ARTSINCLUDE="$(find $KDEPFAD|grep soundserver.h$)"
ARTSINCLUDE="$(echo $ARTSINCLUDE|sed 's/soundserver.h//')"

# hier eigenen Pfad eintragen:
# KDELIBS=/kderoot kdeversion/lib
# ARTSINCLUDE=/kderoot kdeversion/include/arts

if [ ! -d $KDELIBS ]
then
echo "aRts-Bibliothekspfad $KDELIBS not found! Please enter manually in $0!"
exit 1
fi

if [ ! -d $ARTSINCLUDE ]
then
echo "aRts-Headerpfad $ARTSINCLUDE not found! Please enter manually in $0!"
exit 1
fi

echo
echo "Soundlibraries found in $KDELIBS and $ARTSINCLUDE"


###################################################################################################################

# Programkopf: 
################
echo "----------------------------------------------"
echo "Installation Fleur2 KDE/aRts english"
echo "----------------------------------------------"

######################################################
# Subroutinen:
# compiling, linking:
mach_hin()
{
echo "Compile, Link"
echo "--------------------------------------"
make
ret=$?
if [ $ret -ne 0 ] 
then
 echo "Error: Could not compile/link program"
 exit 2
fi

echo Installation successful
echo ----------------------------------------
}


# Ende Subroutinen
##########################################################

$path
cd fleur2
workdir=$PWD

echo " Step 1: Generating .pro-files:"
echo "---------------------------------"

cat >fleur2.pro<<ENDCAT
# fleur2.pro - generiert von bash
##################################
TEMPLATE = app
TARGET = fleur2

INCLUDEPATH += . ./english ./arts $ARTSINCLUDE
LIBS        += -lsoundserver_idl -L$KDELIBS

CONFIG += qt

# Input
HEADERS +=  english/lang.h config.h gamelib.h window.h levels.h game.h arts/lala.h arts/arts.h
SOURCES +=  main.cpp gamelib.cpp window.cpp levels.cpp game.cpp arts/lala.cpp arts/arts.cpp
ENDCAT

echo "fleur2.pro done"
echo "-------------------------"
echo


echo
echo "Step 2: Generating Makefile "
echo "---------------------------------------------------"

qmake fleur2.pro
ret=$?
if [ $ret -ne 0 ]
then
 echo "Error: Could not generate Makefile! (QTDIR / aRts-Libs available?)"
 exit 1
fi
mach_hin

echo "Installation editor "
qmake editor_engl.pro
ret=$?
if [ $ret -ne 0 ]
then
 echo "Error: Could not generate Makefile! (QTDIR available?)"
 exit 1
fi
mach_hin

echo "Cleaning up"
echo "--------------------------------------"
for i in $( ls *.o  )
do 
  rm $i
done
for i in $( ls moc*  )
do 
  rm $i
done
rm Makefile
rm arts/moc*

echo "Installation done"
echo "To start, point to directory fleur2, enter ./fleur2"
echo "============================================================================"
exit 0

####################################################################################


