#!/bin/sh
##########################################################
# Installer ujagames_qt: fleur2 english NAS-Soundserver #
##########################################################

###################################################################################################################

# Programkopf: 
################
echo "----------------------------------------------"
echo "Installation Fleur2 X11/NAS english"
echo "----------------------------------------------"

######################################################
# Subroutinen:
# compiling, linking:
mach_hin()
{
echo "Compile, Link"
echo "--------------------------------------"
make
ret=$?
if [ $ret -ne 0 ] 
then
 echo "Error: Could not compile/link program"
 exit 2
fi

echo Installation successful
echo ----------------------------------------
}


# Ende Subroutinen
##########################################################

$path
cd fleur2
workdir=$PWD


qmake fleur2_nas_engl.pro
ret=$?
if [ $ret -ne 0 ]
then
 echo "Error: Could not generate Makefile! (QTDIR available?)"
 exit 1
fi
mach_hin

echo "Installation editor "
qmake editor_engl.pro
ret=$?
if [ $ret -ne 0 ]
then
 echo "Error: Could not generate Makefile! (QTDIR available?)"
 exit 1
fi
mach_hin

echo "Cleaning up"
echo "--------------------------------------"
for i in $( ls *.o  )
do 
  rm $i
done
for i in $( ls moc*  )
do 
  rm $i
done
rm Makefile
rm nas/moc_lala.cpp

echo "Installation done"
echo "To start, point to directory fleur2, enter ./fleur2"
echo "============================================================================"
exit 0

####################################################################################
